local bitmap1 = Bitmap.new(Texture.new("bird1.png"))
local bitmap2 = Bitmap.new(Texture.new("bird2.png"))
local bitmap3 = Bitmap.new(Texture.new("bird3.png"))

bitmap1:setPosition(140, 12)
bitmap2:setPosition(140, 12)
bitmap3:setPosition(140, 12)

bitmap1:setBlendMode(Sprite.ALPHA)
bitmap2:setBlendMode(Sprite.ADD)
bitmap3:setBlendMode(Sprite.ADD)

stage:addChild(bitmap1)
stage:addChild(bitmap2)
stage:addChild(bitmap3)

local redbar = Bitmap.new(Texture.new("red-bar.png"))
redbar:setPosition(91, 230)
stage:addChild(redbar)

local greenbar = Bitmap.new(Texture.new("green-bar.png"))
greenbar:setPosition(91, 260)
stage:addChild(greenbar)

local bluebar = Bitmap.new(Texture.new("blue-bar.png"))
bluebar:setPosition(91, 290)
stage:addChild(bluebar)

local reddot = Bitmap.new(Texture.new("red-dot.png"))
reddot:setY(222)
stage:addChild(reddot)

local greendot = Bitmap.new(Texture.new("green-dot.png"))
greendot:setY(252)
stage:addChild(greendot)

local bluedot = Bitmap.new(Texture.new("blue-dot.png"))
bluedot:setY(282)
stage:addChild(bluedot)

local function HSVMatrix(h, s, v)
    local vsu = v * s * math.cos(h * math.pi / 180);
    local vsw = v * s * math.sin(h * math.pi / 180);

    local rr = .299 * v + .701 * vsu + .168 * vsw
    local rg = .587 * v - .587 * vsu + .330 * vsw
    local rb = .114 * v - .114 * vsu - .497 * vsw

    local gr = .299 * v - .299 * vsu - .328 * vsw
    local gg = .587 * v + .413 * vsu + .035 * vsw
    local gb = .114 * v - .114 * vsu + .292 * vsw

    local br = .299 * v - .300 * vsu + 1.25 * vsw
    local bg = .587 * v - .588 * vsu - 1.05 * vsw
    local bb = .114 * v + .886 * vsu - .203 * vsw

	return rr, rg, rb, gr, gg, gb, br, bg, bb
end


local function onEnterFrame(event)
	local t = os.timer()
	
	local h = (math.sin(t * 0.9 + 0.3) + 1) / 2
	local s = (math.sin(t * 0.7 + 0.2) + 1) / 2
	local v = (math.sin(t * 0.5 + 0.6) + 1) / 2
	
	-- h = 0
	v = 1
	s = 1
			
	local rr, rg, rb, gr, gg, gb, br, bg, bb = HSVMatrix(h * 360, s, v)

	bitmap1:setColorTransform(rr, gg, bb)
	bitmap2:setColorTransform(rg, gb, br)
	bitmap3:setColorTransform(rb, gr, bg)

	reddot:setX(90 + h * 280)
	greendot:setX(90 + s * 280)
	bluedot:setX(90 + v * 280)
end

stage:addEventListener(Event.ENTER_FRAME, onEnterFrame)
